<?php
$targetDir = "audio_recordings/"; // Ensure this directory exists and is writable

// Check if the audio file and participant ID are set
if (isset($_FILES['audio']) && isset($_POST['pid'])) {
    // Sanitize the participant ID
    $participantId = preg_replace("/[^a-zA-Z0-9]+/", "", $_POST['pid']);

    $fileExt = ".webm"; // Expected file extension

    // Construct the file name using the participant ID and task code
    $taskCode = "NART"; // Adjust the task code as needed
    $fileName = $participantId . "_" . $taskCode . $fileExt;
    $targetFile = $targetDir . basename($fileName);

    // Ensure the target directory exists
    if (!file_exists($targetDir)) {
        mkdir($targetDir, 0777, true);
    }

    // Move the uploaded audio file to the target directory
    if (move_uploaded_file($_FILES['audio']['tmp_name'], $targetFile)) {
        echo "The file $fileName has been uploaded.";

        // Specify the output filename, changing the extension to .mp3
        $convertedFileName = $targetDir . $participantId . "_" . $taskCode . ".mp3";

        // Construct the FFmpeg command for conversion
        $command = "ffmpeg -i \"$targetFile\" -acodec libmp3lame \"$convertedFileName\"";

        // Execute the FFmpeg command
        exec($command, $output, $returnCode);

        // Check the result of the FFmpeg command
        if ($returnCode === 0) {
            echo " Conversion to MP3 successful.";
            // Optionally, delete the original WebM file to save space
            unlink($targetFile);
        } else {
            echo " Error during conversion.";
        }
    } else {
        echo "Error uploading the file.";
    }
} else {
    echo "No audio file or participant ID provided.";
}
?>
