<?php
$targetDir = "audio_recordings/"; // Ensure this directory exists and is writable

// Extract participant ID from the POST data (since it's sent via a POST request)
$participantId = isset($_POST['pid']) ? preg_replace("/[^a-zA-Z0-9]+/", "", $_POST['pid']) : "unknown"; // Sanitize the input

$fileExt = ".webm"; // The expected file extension, WebM is common for audio blobs

// Set the task code to reflect the current task, "switchvft" seems appropriate
$taskCode = "switch"; // Task code
$fileName = $participantId . "_" . $taskCode . $fileExt;
$targetFile = $targetDir . basename($fileName);

// Ensure the audio recordings directory exists
if (!file_exists($targetDir)) {
    mkdir($targetDir, 0755, true); // Changed permissions to 0755 for better security
}

// Move the uploaded file to the target directory
if (move_uploaded_file($_FILES['audio']['tmp_name'], $targetFile)) {
    echo "The file $fileName has been uploaded.";

    // Specify the output filename, changing extension to .mp3
    $convertedFileName = $targetDir . $participantId . "_" . $taskCode . ".mp3";

    // Construct the FFmpeg command for conversion
    $command = "ffmpeg -i " . escapeshellarg($targetFile) . " -acodec libmp3lame " . escapeshellarg($convertedFileName);

    // Execute the command
    exec($command, $output, $returnCode);

    // Check if FFmpeg successfully converted the file
    if ($returnCode === 0) {
        echo " Conversion to MP3 successful.";
        // Optionally, delete the original file to save space
        unlink($targetFile);
    } else {
        echo " Error during conversion.";
    }
} else {
    echo "Error uploading the file.";
}
?>
